Program Sample (input,output);

{Copyright 1990 by Sean A.R. Haynes.  All Rights Reserved                  }
{This program will send the "Display Setup Command" to the modem.  It will }
{then go into an echo to modem mode which will echo all keyboard output to }
{the modem.  It will exit if an Extended Key is pressed (function, cursor, }
{etc.                                                                      }

{Known Bugs:  Because this is just a sample program, I have not set up any }
{buffering techniques.  This will cause a problem when the computer        }
{attempts to scroll the display screen at speeds higher then 1200 Baud.    }
{See the appropriate documentation for techniques on solving this problem. }

Uses Modem,CRT,Dos;

Const
     VidInt = $10;
     WriteChar = $0E;

var
   PortStat,ModStat,IERVal : Byte;
   Regs : Registers;
   DisPage : Byte;
   Choice : Char;
   Extended : Boolean;

Procedure Com2ISR; Interrupt; {COM Port 2 ISR}

var
   IIRVal : Byte;

Begin
     DisableInterrupts;
     IIRVal := Port[Com[2]+IIR];
     While IIRVal and $01 = $00 do {Interrupt Pending}
           Begin
           Case IIRVal of
                0 : Port_Stat(2,PortStat,ModStat);
                4 : Begin
                    Regs.AH := WriteChar;  {Write Char in TTY Mode}
                    Regs.AL := Byte(Read_Char(2));
                    Regs.BH := DisPage;
                    Intr(VidInt,Regs);
                    End;
                6 : Port_Stat(2,PortStat,ModStat);
                End;
           IIRVal := Port[Com[2]+IIR];
           End;
     Port[$0020] := $20; {Clear HW Interrupt}
     EnableInterrupts;
End;

Begin
     DisableInterrupts;
     ClrScr;
     Regs.AH := $0F;
     Intr(VidInt,Regs);
     DisPage := Regs.BH;                        {Get Current Display Page}
     Init_Port(2,9600,0,1,8,PortStat,ModStat);  {Initial Port 9600,N,8,1}
     HookCom24(@Com2ISR);                       {Hook Com2&4}
     IntEna(2,$01);                             {Enable Int on Com 2}
     EnableInterrupts;                          {Enable HW Ints}
     Send_String(2,'AT&V'#13);
     Delay(5000);
     ClrScr;
     Extended := False;
     Repeat
           Choice := ReadKey;
           If Choice = #0 then
              Extended := True
           Else
           Send_Char(2,Choice,PortStat,ModStat);
     Until Extended;
     Choice := ReadKey;
     UnHook;
     IntDis(2);
End.